;; Copyright 2007, 2008, 2009, 2010, 2013, 2015, 2017 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------------------------------------------------------------------

gtk_window_new()
gtk_window_new

/usr/share/gtk-doc/html/
/usr/share/gtk-doc/html/glib/glib.devhelp2
/usr/share/gtk-doc/html/
/usr/share/gtk-doc/html/*/*.devhelp*
/usr/local/share/gtk-doc/html/*/*.devhelp*")

(setq gtk-lookup-devhelp-indices
      '("/usr/share/gtk-doc/html/glib/glib.devhelp2"))

(progn
  (gtk-lookup-reset)
  (gtk-lookup-cache-init))
gtk-lookup-cache
(progn
  (switch-to-buffer "*scratch*")
  (dolist (elem (car (gtk-lookup-cache-init)))
    (pp elem)))
(length (gtk-lookup-cache-init))
(gtk-lookup-symbol-method-candidates "new")
(assoc "gtk_window_new" (gtk-lookup-cache-init))
(assoc "gtk_window_new()" (gtk-lookup-cache-init))
(assoc "gtk_window_new ()" (gtk-lookup-cache-init))


;;-----------------------------------------------------------------------------
;; check for non-ascii in cache entries

(progn
  (require 'gtk-look)
  (gtk-lookup-reset)
  (gtk-lookup-cache-init)
  (let (ret)
    (dolist (elem gtk-lookup-cache)
      ;; (NAME LINK DIR TYPE)
      (let* ((name (nth 0 elem))
             (link (nth 1 elem))
             (dir  (nth 2 elem))
             (type (nth 3 elem)))
        (when (string-match "[^[:ascii:]]" name)
          (error "non-ascii: %S\n%S" name elem))
        (when (string-match "[^a-zA-Z0-9_]" name)
          (push (format "non-symbol char: %S\n%S" name elem)
                ret))))
    ret))

;;-----------------------------------------------------------------------------
;; emacs20 Gtk2::UIManager->new
(gtk-lookup-canonicalize-symbol "Gtk2::UIManager->new")

(string-match "\\([A-Z][A-Z]+\\)\\([A-Z][a-z]\\)"
              "Gtk::UIManager->new")



;;-----------------------------------------------------------------------------
(progn
  (add-to-list 'load-path (expand-file-name ".."))

  (unless (fboundp 'file-expand-wildcards)
    (autoload 'file-expand-wildcards "../tests/file-expand-wildcards"))
    ;; (byte-compile-file "../gtk-look.el")

  (autoload 'gtk-lookup-symbol "gtk-look" nil t)
  (define-key global-map [?\C-h ?\C-j] 'gtk-lookup-symbol)
  
  ;; (setq browse-url-browser-function 'browse-url-w3)
  ;;   (setq browse-url-browser-function 'browse-url-lynx-emacs)
  
  (cond ((fboundp 'w3m-browse-url)
	 (setq browse-url-browser-function 'w3m-browse-url))
	(t
	 (setq browse-url-browser-function 'browse-url-lynx-emacs))))

gtk_accel_label_new
gtk_label_new
GtkLabel
gtk-container-children
Gtk2->gtk_init
Glib->G_PRIORITY_LOW

(setq debug-on-error t)
(gtk-lookup-symbol-suffix "get_screen")

;;-----------------------------------------------------------------------------
;; stock ids

(gtk-lookup-canonicalize-symbol "gtk-quit")
(gtk-lookup-canonicalize-symbol "gtk-go-forward")
(gtk-lookup-canonicalize-symbol "gtkgo-forward")
(let ((str "gtk-go-forward"))
  ;; digits allowed for "gtk-zoom-100" GTK_STOCK_ZOOM_100
  (let ((stock (and (string-match "\\`gtk-[a-z0-9-]+\\'" str)
                    (let ((symbol (upcase (concat (substring str 0 4)
                                                  "STOCK_"
                                                  (substring str 4)))))
                      (while (string-match "-" symbol)
                        (setq symbol (replace-match "_" t t symbol)))
                      (assoc symbol (gtk-lookup-cache-init))
                      symbol))))
    stock))

(mapcar 'car (remove* "\\`GTK_STOCK_.*[0-9]" (gtk-lookup-cache-init)
                      :test-not 'string-match
                      :key 'car))

(gtk-lookup-assoc-string-ignore-case "gtk_quit" (gtk-lookup-cache-init))

;; GNOME_STOCK_BUTTON_YES
(let ((case-fold-search nil)
      (lst (mapcar 'car (gtk-lookup-cache-init))))
  (setq lst (remove* "_STOCK_" lst :test-not 'string-match))
  (setq lst (remove* "\\`GTK_" lst :test 'string-match))
  lst)




;;-----------------------------------------------------------------------------
;; GtkWidgetClass

(progn
  (require 'gtk-look)
  (let (ret)
    (dolist (elem (gtk-lookup-cache-init))
      (let ((key (car elem)))
        (when (string-match "Class\\'" key)
          (push key ret)
          (message "%S" key))))
     ret))


;;-----------------------------------------------------------------------------
;; gtk-lookup-cache-init -- contents

;; sorted symbols
(progn
  (require 'gtk-look)
  (switch-to-buffer "*d-gtk-look.el names*")
  (erase-buffer)
  (dolist (name (sort (mapcar 'car (gtk-lookup-cache-init)) 'string<))
    (insert name "\n"))
  (insert (format "total %S" (length gtk-lookup-cache))))

;; counts by file
(progn
  (require 'gtk-look)
  (let ((filenames (apply 'append (mapcar 'file-expand-wildcards
                                          gtk-lookup-devhelp-indices)))
        empty)
    (setq filenames (mapcar 'file-truename filenames))
    (setq filenames (sort filenames 'string<))
    (require 'cl)
    (setq filenames (delete-duplicates filenames :test 'equal))
    ;;     (setq filenames (remove* "/gtk-\\(faq\\|tutorial\\)\\.devhelp\\(\\.gz\\)?\\'"
    ;;                              filenames :test 'string-match ))

    (switch-to-buffer "*d-gtk-look.el counts*")
    (erase-buffer)
    (dolist (filename filenames)
      (let ((gtk-lookup-devhelp-indices (list filename)))
        (gtk-lookup-reset)
        (insert (format "%4d %s\n"
                        (length (gtk-lookup-cache-init))
                        filename))
        (if (null gtk-lookup-cache)
            (push filename empty))))

    (insert "\nempty:\n")
    (dolist (filename empty)
      (insert filename "\n"))
    (gtk-lookup-reset)))


(let ((filename "/usr/share/doc/libgnomeui-doc/html/libgnomeui.devhelp.gz"))
  (let ((gtk-lookup-devhelp-indices (list filename)))
    (gtk-lookup-reset)
    (gtk-lookup-cache-init)
    (setq n1 (sort (mapcar 'car gtk-lookup-cache) 'string<)))
  (setq filename
        (replace-regexp-in-string "\\.devhelp" ".devhelp2" filename t t))
  (let ((gtk-lookup-devhelp-indices (list filename)))
    (gtk-lookup-reset)
    (gtk-lookup-cache-init)
    (setq n2 (sort (mapcar 'car gtk-lookup-cache) 'string<)))

  (sort (set-difference n2 n1 :test 'equal) 'string<))

(length n1)
(length n2)
(length (remove-if (lambda (elem)
                     (equal elem (cadr (member elem n1))))
                   n1))
                                          

;;-----------------------------------------------------------------------------
;; possible devhelp2 type="" values

(progn
  (require 'gtk-look)
  (let ((filenames (apply 'append (mapcar 'file-expand-wildcards
                                          gtk-lookup-devhelp-indices)))
        types)
    (setq filenames (mapcar 'file-truename filenames))
    (setq filenames (sort filenames 'string<))
    (require 'cl)
    (setq filenames (delete-duplicates filenames :test 'equal))

    (require 'lisp-mnt)
    (dolist (filename filenames)
      (lm-with-file filename
        (goto-char (point-min))
        (while (re-search-forward "type=\"\\([^\"]*\\)\"" nil t)
          (add-to-list 'types (match-string 1)))))

    (sort types 'string<)))

;;-----------------------------------------------------------------------------
;; possible devhelp1 link suffix values

(progn
  (require 'gtk-look)
  (setq links nil)
  (let ((filenames (apply 'append (mapcar 'file-expand-wildcards
                                          gtk-lookup-devhelp-indices))))
    (setq filenames (mapcar 'file-truename filenames))
    (setq filenames (sort filenames 'string<))
    (require 'cl)
    (setq filenames (delete-duplicates filenames :test 'equal))
    (setq filenames (remove* "devhelp2" filenames :test 'string-match))

    (require 'lisp-mnt)
    (dolist (filename filenames)
      (lm-with-file filename
        (goto-char (point-min))
        (while (re-search-forward "link=\"[^\"]*#[^\"]*-\\([^\"]*\\)\"" nil t)
          (let ((link (match-string 1)))
            (unless (string-match "\\.html\\'" link)
              (add-to-list 'links link))))))

    (sort links 'string<)))


;;-----------------------------------------------------------------------------
;; gtk-lookup-completing-help-get

(progn
  (setq gtk-lookup-devhelp-indices
        '("/usr/share/gtk-doc/html/glib/glib.devhelp"))
  (gtk-lookup-reset)
  (car (gtk-lookup-cache-init)))
Glib->G_PRIORITY_LOW
(gtk-lookup-completing-help-get "G_PRIORITY_LOW")

;;-----------------------------------------------------------------------------

(progn
  (require 'cl)
  (remove* "add_action" (mapcar 'car (gtk-lookup-cache-init))
           :test-not 'string-match))

(progn
  (setq gtk-lookup-devhelp-indices
        (list (expand-file-name "d-gtk-look.devhelp2")))
  (gtk-lookup-reset)
  (gtk-lookup-cache-init))

;;-----------------------------------------------------------------------------
;; browse other window

(gtk-lookup-browse-url-other-window "file:///usr/share/doc/libgnomecanvas2-doc/html/GnomeCanvas.html#gnome-canvas-new")
(browse-url "file:///usr/share/doc/libgnomecanvas2-doc/html/GnomeCanvas.html#gnome-canvas-new")

;;-----------------------------------------------------------------------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

(progn
  (elint-initialize)
  (find-file "../gtk-look.el")
  (elint-current-buffer))


;;-----------------
;; XML::LibXML maybe
;; but most of it is not named for the C funcs anyway ...

              ("XML::LibXML::LIBXML_DOTTED_VERSION" "LIBXML_DOTTED_VERSION")

      ;; libxml "XML::LibXML::LIBXML_DOTTED_VERSION" -> "LIBXML_DOTTED_VERSION"
      (if (string-match "\\`XML::LibXML::\\(LIBXML\\)" str)
          (setq str (substring str (match-beginning 1))))


;;-----------------


(setq browse-url-browser-function 'browse-url-lynx-emacs)
(progn
  (setq browse-url-browser-function 'browse-url-text-emacs))
(setq browse-url-browser-function 'w3m-browse-url)
(progn
  (setenv "DISPLAY" ":0")
  (setq browse-url-browser-function 'browse-url-mozilla))

(gtk-lookup-browse-url-other-window
 "file:///usr/share/doc/libgtk2.0-doc/gtk/GtkLabel.html")


(browse-url-lynx-emacs "file:///usr/share/doc/libgtk2.0-doc/gtk/GtkLabel.html"
		       t)
(browse-url "file:///usr/share/doc/libgtk2.0-doc/gtk/GtkLabel.html")
(browse-url-w3 "file:///usr/share/doc/libgtk2.0-doc/gtk/GtkLabel.html")
(w3-fetch-other-window "file:///usr/share/doc/libgtk2.0-doc/gtk/GtkLabel.html")


(switch-to-buffer-other-window "xx")
(switch-to-buffer-other-window "yy")
