;; Copyright 2011, 2012 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.



(describe-function 'thing-at-point)

(progn
  (load (expand-file-name "my-load-all.el"))
  (my-load-all--autoloads)
  ;; (my-load-all--libraries)
  )

(describe-variable 'init-file-user)    .emacs
user-init-file
locate-user-emacs-file


(defun foo ()
  "Foo.
table.el-style
.emacs,
~/.emacs.
~/.emacs;
.emacs.elc,
/ftp:foo@bar:/tmp/x.el
~/.emacs
.emacs
~/.emacs.d
~/.emacs.d/srecode-map.el
~/.emacs.d/nosuch.el
~/.emacs-custom.el
~/.emacs-nosuch.el
/usr/foo/.emacs
"
  nil)

(let ((output-buffer "*help-xref-elfiles* stuff"))
  (flet ((show (desc)
               (if desc
                   (with-temp-buffer
                     (insert desc)
                     (goto-char (point-min))
                     (while (re-search-forward
                             "[^][(){}<>,;`'\" \t\r\n\f]+"
                             ;; "\\([^ \t\r\n]+\\.el\\)"
                             ;; "[^ \t\r\n]*\\.emacs[^ \t\r\n]*"
                             nil t)
                       (let ((filename (match-string 0)))
                         (if (string-match "\\.emacs\\|\\.el" filename)
                             (with-current-buffer output-buffer
                               (insert (format "%-35S %s\n" symbol filename))
                               (redisplay t)))))))))

    (switch-to-buffer output-buffer)
    (erase-buffer)

    (insert "faces:\n")
    (mapatoms
     (lambda (symbol)
       (show (face-documentation symbol))))
    (insert "\n")

    (insert "groups:\n")
    (mapatoms
     (lambda (symbol)
       (show (documentation-property
              symbol 'group-documentation
              t ;; raw, no substitute-keys
              ))))
    (insert "\n")

    (insert "variables:\n")
    (mapatoms
     (lambda (symbol)
       (show (and (boundp symbol)
                  (documentation-property
                   symbol 'variable-documentation
                   t ;; raw, no substitute-keys
                   )))))
    (insert "\n")

    (insert "functions:\n")
    (mapatoms
     (lambda (symbol)
       (show (and (fboundp symbol)
                  (symbol-function symbol)
                  (condition-case nil
                      (documentation symbol
                                     t ;; raw, no substitute-keys
                                     ) (error nil))))))
    (insert "\n")

    (goto-char (point-min))))

;;----------------------------------------------------------------------------

;; (add-hook 'help-mode-hook 'help-xref-elfiles-filename-buttonize)

;; align.el
;; dunnet.el




(progn
  (switch-to-buffer "*help-xref-elfiles* stuff")
  (erase-buffer)
  (mapatoms
   (lambda (symbol)
     (if (and (fboundp symbol)
              (symbol-function symbol))
         (let ((desc (condition-case nil (documentation symbol) (error nil))))
           (if (and desc
                    (string-match "\\(^\\|\\s-\\|[(]\\)\
\\([/~][^ \t\r\n]+\
\\|\\.emacs\\b\
\\)" desc))
               (let ((filename (match-string 2 desc)))
                 (if (string-match "[.,;:\"]\\'" filename)
                     (setq filename (substring filename 0 -1)))
                 (if (equal ".emacs" filename)
                     (setq filename user-init-file))
                 (if (and (not (member filename '("/" "//" "/*")))
                          ;; (not (string-match "[*?]" filename))
                          (not (file-remote-p filename))
                          (or (file-regular-p filename)
                              (file-directory-p filename))
                          )
                     (progn
                       (insert (format "%-40S  %S\n" symbol filename))
                       (redisplay t)
                       '(if (and (file-exists-p filename))
                            (progn
                              ))))))))))
  (goto-char (point-min)))
(goto-char (point-min)))



;;-----------------
(defalias 'xyzzy 'foo)
(symbol-function 'xyzzy)
(symbol-plist 'xyzzy)
(symbol-function 'message-delete-overlay)

;;-----------------
;; no non-greedy in emacs20
(progn
  (string-match "x+?" "xxx")
  (match-end 0))


;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))
(progn
  (elint-initialize)
  (find-file "../help-xref-elfiles.el")
  (elint-current-buffer))
