;; Copyright 2013, 2016, 2017 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(progn
  (switch-to-buffer "x")
  (erase-buffer)
  (insert "<IMG
 WIDTH=\"96\" HEIGHT=\"34\" ALIGN=\"MIDDLE\" BORDER=\"0\"
 SRC=\"img1545.png\"
 ALT=\"$\\ldots \\displaystyle \\ensuremath{\\mathtt{c[a[i]]}} = 1 \\enspace .
$\">
")
  (my-w3m-filter-img-alt-tex nil)
  )

;;-----------------------------------------------------------------------------
(add-hook 'emacs-lisp-mode-hook
          (lambda ()
            (message "emacs-lisp-mode of %s" buffer-file-name)
            (setq lexical-binding t)))



;;-----------------------------------------------------------------------------
;; whizzytex set-mark
;; /usr/share/emacs/site-lisp/whizzytex/whizzytex.el

(defadvice set-mark (before my-whizzytex-debug activate)
  (message "set-mark %S at %s"
           (ad-get-arg 0)
           (with-output-to-string (backtrace))))
(defadvice set-mark (before my-whizzytex-debug activate)
  )


;;-----------------------------------------------------------------------------
;; package upload
;; ~/tux/data/elpa
;; ~/.emacs.d/elpa
;;

(setq package-archives '(
                         ;; ("user42" . "http://download.tuxfamily.org/user42/elpa/packages/")
                         ("user42" . "~/tux/data/elpa/packages/")
                         ;; ("gnu" . "http://elpa.gnu.org/packages/")
                         ))
(progn
  (find-file "~/tux/data/elpa/packages/archive-contents")
  (kill-buffer)
  (delete-directory "~/tux/data/elpa/packages/" t))

(progn
  (require 'package-x)
  (setq package-archive-upload-base "~/tux/data/elpa/packages/")
  (ignore-errors (delete-directory package-archive-upload-base t))
  (make-directory package-archive-upload-base t)

  ;; reverse so archive-contents is sorted alphabetically
  (dolist (filename (reverse (file-expand-wildcards "~/tux/data/*.el")))
    (package-upload-file filename)))
;; ~/tux/data/elpa/packages/archive-contents


;; two versions of a .el
;; the older is left behind, only the newer in the archive-contents
(progn
  (require 'package-x)
  (setq package-update-news-on-upload t)
  (setq package-archive-upload-base "/tmp/try/packages/")
  (ignore-errors (delete-directory package-archive-upload-base t))
  (make-directory package-archive-upload-base t)
  (ignore-errors (delete-file "/tmp/align-let.el"))
  (copy-file "~/p/el/align-let.el" "/tmp/align-let.el")
  (package-upload-file "~/tux/web/align-let/rel/3/align-let.el")
    (package-upload-file "/tmp/align-let.el")
  (find-file package-archive-upload-base))

;; accjournal .tar.gz as package, not quite right
(progn
  (delete-directory "/tmp/try/packages/" t)
  (setq package-update-news-on-upload t)
  (setq package-archive-upload-base "/tmp/try/packages/")
  (make-directory package-archive-upload-base t)
  (ignore-errors (delete-file "/tmp/accjournal-7.tar.gz"))
  (ignore-errors (delete-file "/tmp/accjournal-7.tar"))
  (copy-file "~/p/ac/accjournal-7.tar.gz" "/tmp/accjournal-7.tar.gz")
  (shell-command "gunzip /tmp/accjournal-7.tar.gz")
  (require 'package-x)
  (package-upload-file "/tmp/accjournal-7.tar")
  (find-file package-archive-upload-base))

;; accjournal.el alone
(progn
  (delete-directory "/tmp/try/packages/" t)
  (setq package-update-news-on-upload t)
  (setq package-archive-upload-base "/tmp/try/packages/")
  (make-directory package-archive-upload-base t)
  (copy-file "~/p/ac/accjournal.el" "/tmp/accjournal.el")
  (require 'package-x)
  (package-upload-file "/tmp/accjournal.el")
  (find-file package-archive-upload-base))

(progn
  (setq package-archives '(("user42" . "/tmp/try/packages/")
                           ;; ("gnu" . "http://elpa.gnu.org/packages/")
                           ))
  (list-packages))





;;-----------------------------------------------------------------------------

comment-start-skip \\s-  matlab.el
comment-start-skip group sgml-mode "\\(<!\\)?--[ \t]*"
	tex-mode
	autoconf-mode dnl preceded by non-word
	js.el comment-start-skip "\\(//+\\|/\\*+\\)\\s *"
	cf vera-mode.el /usr/share/emacs/24.3/lisp/progmodes/vera-mode.el.gz


;;-----------------------------------------------------------------------------

(defadvice message (before my-wrote-dev-null)
  (setq wrote-dev-null t)
  (let ((standard-output (get-buffer-create "*wrote-dev-null*")))
    (backtrace)))
(setq wrote-dev-null nil)
(message "foo")
(switch-to-buffer "*wrote-dev-null*")
# Math::PlanePath::CellularRule

;;-----------------------------------------------------------------------------

(let (lst)
  (mapatoms (lambda (symbol)
              (if (string-match "\\`\\." (symbol-name symbol))
                  (push symbol lst))))
  (setq lst (mapcar 'symbol-name lst))
  (setq lst (sort lst 'string-lessp))
  (dolist (str lst)
    (insert (format "%S\n" str))))
"..."
".loaddefs"
".tlc-mode"

