;; Copyright 2007, 2008, 2009, 2012, 2013 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;; Maybe:
;; perl-quote-single use parse partial to find start of string.
;; Would that work on qq{} too ?



;;-----------------

(compile "cd $HOME/lisp; set -x;
emacs22     -batch -q -no-site-file -f batch-byte-compile perl-quote.el;
emacs21     -batch -q -no-site-file -f batch-byte-compile perl-quote.el;
xemacs21    -batch -q -no-site-file -f batch-byte-compile perl-quote.el;
emacs-cvs-b -batch -q -no-site-file -f batch-byte-compile perl-quote.el;
rm perl-quote.elc")


;;-----------------

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (require 'perl-quote))

;;-----------------

(progn
  (add-to-list 'load-path "..")
  (require 'perl-quote)
  (find-file "t-perl-quote.pl")
  (perl-quote-enable)
  (font-lock-mode 1))
(setq debug-on-error t)

;;-----------------

(let ((tempfile "/tmp/x.el")
      (print-level nil))
  (require 'autoload)
  (find-file tempfile)
  (erase-buffer)
  (generate-file-autoloads "../perl-quote.el")
  (save-buffer)
  (byte-compile-file tempfile)
  (delete-file (concat tempfile "c"))
  (delete-file tempfile))

;;-----------------
;; parse-partial-sexp
;; (cperl-update-syntaxification lim lim)
;; syntax-table property
;; syntax-type property

(defun perl-quote-beginning-of-string ()
  "Move point back to the start of a string.
Strings are recognised by a `parse-partial-sexp' starting from
`beginning-of-defun'."

  (let ((old (point)))
    (beginning-of-defun)
    (let ((parse (parse-partial-sexp (point) old)))
      (cond ((nth 2 parse) ;; innermost sexp
             (goto-char (nth 2 parse))
             (forward-sexp))
            ((nth 8 parse) ;; outside of comment or string
             (goto-char (nth 8 parse)))
            ((nth 5 parse) ;; after a quote char
             (goto-char (1- (point))))))))


;;-----------------


jkfdsjf ksdf jksd fjksd  fdksjjf dskfj sdkf fdjksf jksd fjksd jf
ksd 


(setq fill-nobreak-predicate nil)
(add-hook 'fill-nobreak-predicate 'fill-french-nobreak-p)


(progn

  (font-lock-mode))

   C<<foo->bar>>
   C<foo->bar>

   C<fE<lt> E<gt>oo->bar->quux>
   C<fE<lt> E<gt>oo->_bar->_Quux>

   C<<foo => bar>>
   C<x => y, a => b>
   C<fE<lt> E<gt>oo=>bar>


(font-lock-add-keywords nil
                        '(("\\(FIXME\\)" 1 font-lock-warning-face prepend)
                          ("\\<\\(and\\|or\\|not\\)\\>" . font-lock-keyword-face)))

FIXME: fdjsk 

(add-to-list 'font-lock-keywords
             ( )
'cperl-font-lock-keywords

;; 'cperl-font-lock-keywords-1
;; 'cperl-font-lock-keywords-2

