;; Copyright 2014 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;; Look for docstrings starting with a "foo.el" elisp filename.

(defun my-function-docstring-raw (symbol)
  "Return string or nil."
  (condition-case nil
      (documentation symbol
                     t) ;; raw
    (error nil)))

(defun my-variable-docstring-raw (symbol)
  "Return string or nil."
  (documentation-property symbol 'variable-documentation))

(defun my-docstring-backslashes ()
  "foo.el blah blah"
  (interactive)

  (require 'info-xref)
  (pop-to-buffer info-xref-output-buffer t)
  (let ((info-xref-filename-heading "")
	(case-fold-search t))

    (info-xref-output "Checking docstring elfile names ...\n")
    (with-temp-buffer
      (mapatoms
       (lambda (symbol)
         (dolist (str (list (my-function-docstring-raw symbol)
                            (my-variable-docstring-raw symbol)))
           (when (and str
                      (string-match "\\`\\(`?[^ ]*\\.el\\b\\)" str))
             (info-xref-output "%s\n  %s\n"
                               symbol (match-string 1 str))))))))
  (info-xref-output "done\n"))

(my-load-all--autoloads)
(my-docstring-backslashes)
