;; Copyright 2007, 2008, 2009, 2010 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(add-to-list 'load-path (expand-file-name ".."))

(defun my-run-test ()
  (require 'miscbits-el-loaddefs)
  (let ((count 0)
        (case-fold-search nil))

    ;;-------------------------------------------------------------------------
    ;; load

    (require 'arc-lzh-exe)

    ;; no leftovers in emacs21 byte compiling defadvice
    (when (and (boundp 'byte-compile-unresolved-functions)
               byte-compile-unresolved-functions)
      (error "byte-compile-unresolved-functions after load: %S"
             byte-compile-unresolved-functions))
    (setq count (1+ count))

    ;; regexp pattern under emacs23, not just a name
    ;; (unless (assoc "arc-mode" after-load-alist)
    ;;   (error "no after-load-alist entry: %S" after-load-alist))
    ;; (setq count (1+ count))


    ;;-------------------------------------------------------------------------
    ;; load - arc-mode too

    ;; (require 'arc-mode) broken in xemacs 21.4.22 as its arc-mode.el
    ;; provides 'archive-mode instead of 'arc-mode
    (load "arc-mode")

    ;; no leftovers in emacs21 byte compiling defadvice
    (when (and (boundp 'byte-compile-unresolved-functions)
               byte-compile-unresolved-functions)
      (error "byte-compile-unresolved-functions after load arc-mode: %S"
             byte-compile-unresolved-functions))
    (setq count (1+ count))


    ;;-------------------------------------------------------------------------
    ;; unload-feature

    (add-to-list 'load-path (expand-file-name "."))
    (require 'my-unload)

    (let* ((feature 'arc-lzh-exe)
           (adv     (my-advice-by-name 'arc-lzh-exe)))

      (unload-feature feature t)

      (if (not adv)
          (message "skip, no advice used under this emacs")
        (if (featurep 'xemacs) ;; no -unload-hook in xemacs
            (message "skip, no FEATURE-unload-hook in xemacs")

          (let ((lst (my-advice-by-name feature)))
            (when lst
              (error "unload-feature leftover advice: %S" lst)))
          (setq count (1+ count)))))

    ;;-------------------------------------------------------------------------
    ;; unload-feature -- with advice unloaded first

    (let ((feature 'arc-lzh-exe))
      (if (featurep feature)
          (unload-feature feature t))
      (require feature)
      ;; if 'advice can be unloaded (no dependency expressed on it), then
      ;; see FEATURE unloads successfully too
      (when (condition-case nil
                (progn (unload-feature 'advice) t)
              (error nil))
        (unload-feature feature t)))
    (setq count (1+ count))

    ;;-------------------------------------------------------------------------
    (message "  %d tests" count)
    count))

