;; Copyright 2010 Kevin Ryde

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(add-to-list 'load-path (expand-file-name ".."))

(defun my-run-test ()

  ;; check `custom-add-option' calls in miscbits-el-loaddefs.el, each
  ;; function added to a hook must be fboundp

  (require 'miscbits-el-loaddefs)
  (let* ((srcdir   (expand-file-name ".."))
         (filename (expand-file-name "miscbits-el-loaddefs.el" srcdir))
         (count    0)
         form)

    (unless (file-exists-p filename)
      (error "no such file %S" filename))
    (find-file filename)

    (goto-char (point-min))
    (catch 'done
      (while (condition-case nil
                 (setq form (read (current-buffer)))
               (end-of-file (throw 'done nil)))
        (when (and (eq 'custom-add-option (car-safe form))

                   ;; special in nroff-filladapt.el
                   (not (equal form
                               '(custom-add-option 'nroff-mode-hook
                                                   'turn-on-filladapt-mode))))

          (let ((func (cadr (nth 2 form))))
            (unless (fboundp func)
              (error "autoload custom-add-option of unknown %S"
                     func))))
        (setq count (1+ count))))

    (message "  %d tests" count)
    count))
